/* VSTDemo5.java */
package sample;

import java.io.*;
import sample.misc.TokenCaster;
import sample.misc.LoggingMonitor;


class VSTDemo5 {
  public static void main(String[] args) {
    // input̏
    Reader input = null;
    if (args.length == 0) {
      input = new InputStreamReader(System.in);
    } else {
      try {
        input = new FileReader(args[0]);
      } catch (Exception e) {
        System.err.println(e);
        System.exit(1);
      }
    }
    // parseȑ
    VSTParserPI parser;
    // output̏
    Writer output = null;
    try {
      output = new FileWriter("tokens.log");
    } catch (Exception e) {
      System.err.println(e);
      System.exit(1);
    }
    // 
    VSTLexerCmp lexerCmp = new VSTLexerCmp();
    VSTParserCmp parserCmp = new VSTParserCmp();
    TokenCaster caster = new TokenCaster();
    LoggingMonitor logMonitor = new LoggingMonitor();
    // CO
    lexerCmp.setInput(input);
    logMonitor.setOutput(output);
    caster.lexerReq = lexerCmp.lexer;
    caster.addMonitor(logMonitor.monitor);    
    parserCmp.lexer = caster.lexerPro;
    parser = parserCmp.parser;
    // s
    try {
      parser.parse();
    } catch (Exception e) {
      System.err.println(e);
      System.exit(1);
    }
    System.exit(0);
  }
}
