/* VSTParserCmp.java */
// VerySimpleTemplates̃p[U[ER|lg
package sample;

import java.io.*;


/* p[U[ */
class VSTParserCmp implements VSTParserPI {
  /* -- component ports */
  // @Provide
  public final VSTParserPI parser;
  // @Require(Occurence.OPTIONAL)
  public VSTHandler handler;
  // @Require
  public VSTLexerPI lexer;
  /* -- end ports */

  public VSTParserCmp() {
    parser = this;
    handler = new PrintHandler(); // ftHg
  }

  private void signalError(String msg) throws VSTParseException {
    handler.error(msg);
    throw new VSTParseException(msg);
  }

  public void parse() throws IOException, VSTParseException {
    boolean withinPlaceholder = false; // 
    StringBuilder placeholderContent = new StringBuilder(); // eLXg~ϗp

    handler.startTemplate();
    while (true) {
      VSTToken tok = lexer.nextToken();
      switch (tok.kind) {
      case L_BRACE:
        if (withinPlaceholder) 
          signalError("unexpected left-brace - nested placeholder.");
        withinPlaceholder = true;
        break;
      case R_BRACE: 
        if (!withinPlaceholder) {
          handler.text("}"); // PȂeLXg
        } else { // withinPlaceholder
          if (placeholderContent.length() == 0) 
            signalError("empty placeholder content.");
          handler.placeholder(placeholderContent.toString());
          withinPlaceholder = false;
          // vCXz_[eNA
          placeholderContent.delete(0, placeholderContent.length());
        }
        break;
      case TEXT:
        if (withinPlaceholder) {
          placeholderContent.append(tok.value); // ~
        } else {
          handler.text(tok.value); // ɂ͂o
        }
        break;
      case EOF:
        if (withinPlaceholder) 
          signalError("unexpected end-of-file - placeholder is not closed.");
        handler.endTemplate();
        return; // EoEI
      default:
        assert false; // AGi[C
      }
    }
  }
}
