/* VSTProcessorCmp.java */
package sample;

import java.io.*;
import java.util.*;
import sample.model.*;

public class VSTProcessorCmp implements VSTProcessorPI {
  /* -- component ports */
  // @Provide
  public final VSTProcessorPI processor;
  // @Require
  public List<Node> model;
  // @Require
  public Evaluator evaluator;
  // @Require
  public void setOutput(Writer writer) {
    output = new PrintWriter(writer);
  }
  // @Require
  public void setOutput(OutputStream stream) {
    setOutput(new OutputStreamWriter(stream));
  }
  /* -- end ports */

  private PrintWriter output;

  public VSTProcessorCmp() {
    processor = this;
  }

  public void process() {
    for (Node node : model) {
      if (node instanceof TextNode) {
	output.print(node.value);
      } else if (node instanceof PlaceholderNode) {
	String val = evaluator.eval(node.value);
	if (val != null) {
	  output.print(val);
	} else {
	  output.print(node.value);
	}
      }
      output.flush();
    }
  }
}
