/* LoggingMonitor.java */
package sample.misc;

import java.io.*;
import sample.*;
import sample.misc.TokenMonitor;

public class LoggingMonitor implements TokenMonitor {
  /* -- component ports */
  // @Provide
  public final TokenMonitor monitor;
  // @Require(Occurrence.OPTIONAL)
  public void setOutput(Writer writer) {
    output = new PrintWriter(writer);
  }
  // @Require(Occurrence.OPTIONAL)
  public void setOutput(OutputStream stream) {
    setOutput(new OutputStreamWriter(stream));
  }
  /* -- end ports */

  private PrintWriter output;

  public LoggingMonitor() {
    monitor = this;
    setOutput(System.out);
  }

  public void tokenPassed(VSTToken tok) {
    if (tok.kind == VSTToken.Kind.TEXT) {
      output.println("'" + tok.value  + "'");
    } else {
      output.println(tok.value);
    }
    output.flush();
  }
}
