/* TokenCaster.java */
package sample.misc;

import java.util.*;
import java.io.*;
import sample.*;
import sample.misc.TokenMonitor;

public class TokenCaster implements VSTLexerPI {
  // ӁFVOXbĥ݂ƂāAr͂Ȃ

  /* -- component ports */
  // @Provide
  public final VSTLexerPI lexerPro; 
  // @Require
  public VSTLexerPI lexerReq; 
  // @Require(Occurrence.ANY)
  public void addMonitor(TokenMonitor mon) {
    if (!monitorList.contains(mon)) monitorList.add(mon);
  }
  // @Require(Occurrence.ANY)
  public void removeMonitor(TokenMonitor mon) {
    monitorList.remove(mon);
  }
  /* -- end ports */

  public TokenCaster() {
    lexerPro = this;
  }

  public VSTToken nextToken() throws IOException {
    VSTToken tok = lexerReq.nextToken();
    sendTokenPassedEvent(tok);
    return tok;
  }

  private List<TokenMonitor> monitorList = new ArrayList<TokenMonitor>();

  public void sendTokenPassedEvent(VSTToken token) {
    for (TokenMonitor mon : monitorList) {
      mon.tokenPassed(token);
    }
  }
}
