/* TokenChecker.java */
package sample.misc;

import java.io.*;
import sample.*;

class NullValueViolation extends RuntimeException {
  public NullValueViolation(String msg) {
    super(msg);
  }
}

public class TokenChecker implements VSTLexerPI {
  /* -- component ports */
  // @Provide
  public final VSTLexerPI lexerPro; 
  // @Require
  public VSTLexerPI lexerReq; 
  /* -- end ports */

  public TokenChecker() {
    lexerPro = this;
  }

  public VSTToken nextToken() throws IOException {
    VSTToken tok = lexerReq.nextToken();
    if (tok.value == null) 
      throw new NullValueViolation("value is null. kind=" + tok.kind);
    return tok;
  }
}
