/* TokenLogger.java */
package sample.misc;

import java.io.*;
import sample.*;

public class TokenLogger implements VSTLexerPI {
  /* -- component ports */
  // @Provide
  public final VSTLexerPI lexerPro; 
  // @Require
  public VSTLexerPI lexerReq; 
  // @Require(Occurence.OPTIONAL)
  public void setOutput(Writer writer) {
    output = new PrintWriter(writer);
  }
  // @Require(Occurence.OPTIONAL)
  public void setOutput(OutputStream stream) {
    setOutput(new OutputStreamWriter(stream));
  }
  /* -- end ports */

  private PrintWriter output;

  public TokenLogger() {
    lexerPro = this;
    setOutput(System.out);
  }

  public VSTToken nextToken() throws IOException {
    VSTToken tok = lexerReq.nextToken();
    if (tok.kind == VSTToken.Kind.TEXT) {
      output.println("'" + tok.value  + "'");
    } else {
      output.println(tok.value);
    }
    output.flush();
    return tok;
  }
}
